/*
 * Copyright (C) 2013 Philippe Komma
 * 
 * This file is part of Cartoon: A video stream cartoonizer 
 * 
 * Cartoon is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Foobar is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Foobar. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __CARTOON_H__
#define __CARTOON_H__

#include "Program.h"

class Cartoon : public Program
{
	public:

		Cartoon();

		IplImage* exec( IplImage* img );

	protected:

		IplImage* m_imgGray;

		IplImage* m_imgSobelHor;

		IplImage* m_imgSobelVer;

		IplImage* m_imgLaplace;

		IplImage* m_imgResult;

		IplImage* m_imgSmoothed;

		int m_subW;

		int m_subH;

		CvMat* m_matResampled;

		CvMat* m_matLabels;

		int m_numc;

		CvMat* m_matCenters;
};

#endif